searchNodes=[{"doc":"","ref":"Mix.Tasks.Paraxial.Scan.html","title":"Mix.Tasks.Paraxial.Scan","type":"task"},{"doc":"Paraxial.io functions for use by users.","ref":"Paraxial.html","title":"Paraxial","type":"module"},{"doc":"Given an email, bulk action (such as :email), and count, return true or fase.any() Example config: config :paraxial , # ... bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) Examples iex&gt; Paraxial . bulk_allowed? ( &quot;mike@blackcatprojects.xyz&quot; , :email , 3 ) true iex&gt; Paraxial . bulk_allowed? ( &quot;mike@blackcatprojects.xyz&quot; , :email , 100 ) true iex&gt; Paraxial . bulk_allowed? ( &quot;mike@test.xyz&quot; , :email , 4 ) false","ref":"Paraxial.html#bulk_allowed?/3","title":"Paraxial.bulk_allowed?/3","type":"function"},{"doc":"","ref":"Paraxial.html#email_trusted?/2","title":"Paraxial.email_trusted?/2","type":"function"},{"doc":"This plug evaluates if an incoming conn should be allowed or blocked. It should be placed in the endpoint.ex file of a Phoenix application, before the Recorder plug.","ref":"Paraxial.AllowedPlug.html","title":"Paraxial.AllowedPlug","type":"module"},{"doc":"","ref":"Paraxial.AllowedPlug.html#call/2","title":"Paraxial.AllowedPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.AllowedPlug.html#init/1","title":"Paraxial.AllowedPlug.init/1","type":"function"},{"doc":"This plug is used to add metadata to the conn assigns if an IP matches a cloud provider.","ref":"Paraxial.AssignCloudIP.html","title":"Paraxial.AssignCloudIP","type":"module"},{"doc":"","ref":"Paraxial.AssignCloudIP.html#call/2","title":"Paraxial.AssignCloudIP.call/2","type":"function"},{"doc":"","ref":"Paraxial.AssignCloudIP.html#init/1","title":"Paraxial.AssignCloudIP.init/1","type":"function"},{"doc":"Plug used to block cloud provider IPs.","ref":"Paraxial.BlockCloudIP.html","title":"Paraxial.BlockCloudIP","type":"module"},{"doc":"","ref":"Paraxial.BlockCloudIP.html#call/2","title":"Paraxial.BlockCloudIP.call/2","type":"function"},{"doc":"","ref":"Paraxial.BlockCloudIP.html#init/1","title":"Paraxial.BlockCloudIP.init/1","type":"function"},{"doc":"If a user's email is stored in conn.assigns.current_user.email , you can use this plug to do: assign(conn, :paraxial_current_user, conn.assigns.current_user.email)","ref":"Paraxial.CurrentUserPlug.html","title":"Paraxial.CurrentUserPlug","type":"module"},{"doc":"","ref":"Paraxial.CurrentUserPlug.html#call/2","title":"Paraxial.CurrentUserPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.CurrentUserPlug.html#init/1","title":"Paraxial.CurrentUserPlug.init/1","type":"function"},{"doc":"Used to record metadata about requests for processing by Paraxial.io backend.","ref":"Paraxial.RecordPlug.html","title":"Paraxial.RecordPlug","type":"module"},{"doc":"","ref":"Paraxial.RecordPlug.html#call/2","title":"Paraxial.RecordPlug.call/2","type":"function"},{"doc":"","ref":"Paraxial.RecordPlug.html#init/1","title":"Paraxial.RecordPlug.init/1","type":"function"},{"doc":"","ref":"Paraxial.RecordPlug.html#match_plug/3","title":"Paraxial.RecordPlug.match_plug/3","type":"function"},{"doc":"This tutorial is a step-by-step guide to setup your Phoenix application with Paraxial.io. It will walk you through creating a new account, installing the agent in your project, and how to configure rules to protect your application's endpoints. The Phoenix app used in this example is named havana and hosted at the domain blackcatprojects.xyz. If you have questions about Paraxial, need enterprise support, or simply want to provide feedback, email support@paraxial.io","ref":"getting_started.html","title":"Getting started with Paraxial.io","type":"extras"},{"doc":"Go to https://app.paraxial.io/ in your web browser. Create a new account. You will receive a confirmation email, use it to confirm your account and sign in. You have no sites at this point.","ref":"getting_started.html#1-create-your-paraxial-io-account","title":"Getting started with Paraxial.io - 1. Create your Paraxial.io account","type":"extras"},{"doc":"Create a new site for each environment in your application. Most Phoenix applications have the following environments: test dev prod For this example, three sites will be created: test-blackcatprojects.xyz dev-blackcatprojects.xyz prod-blackcatprojects.xyz Replace blackcatprojects.xyz with your project's name.","ref":"getting_started.html#2-create-one-site-for-each-environment","title":"Getting started with Paraxial.io - 2. Create one site for each environment","type":"extras"},{"doc":"Before installing Paraxial, it's recommended you create a new git branch, and then run mix test before making any code changes. Record the output of mix test, to ensure the Paraxial install does not cause tests to fail.","ref":"getting_started.html#3-before-install-run-mix-test","title":"Getting started with Paraxial.io - 3. Before install, run mix test","type":"extras"},{"doc":"Add :paraxial to your mix file and run mix deps.get . {:paraxial, &quot;~&gt; 1.1.0&quot;}","ref":"getting_started.html#4-install-the-agent","title":"Getting started with Paraxial.io - 4. Install the agent","type":"extras"},{"doc":"Open config/dev.exs and add: config :paraxial , paraxial_api_key : &quot;API_KEY&quot; , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true Set the PARAXIAL_API_KEY environment variable to keep this secret out of source code. The api key's value can be found in the site settings for dev-blackcatprojects.xyz . The name of your site will be different. Note that the dev- prefix matches the config file, this is the recommended pattern.","ref":"getting_started.html#5-configure-dev-environment","title":"Getting started with Paraxial.io - 5. Configure dev environment","type":"extras"},{"doc":"You will now add three lines to your endpoint.ex file, two plugs before your router, and one plug after the router: plug Paraxial.AllowedPlug plug Paraxial.RecordPlug plug HavanaWeb.Router plug Paraxial.RecordPlug The reason RecordPlug is placed before and after the router is to collect information about requests that fail to match in the router. The RemoteIP plug should only be used if you are deploying your application behind a proxy. In the example shown, plug RemoteIp, headers: [&quot;fly-client-ip&quot;] is specific to fly.io deployments. Your configuration may be different.","ref":"getting_started.html#6-update-your-endpoint-ex-file","title":"Getting started with Paraxial.io - 6. Update your endpoint.ex file","type":"extras"},{"doc":"Run your application locally with mix phx.server , refreshing the localhost page. Your application should be running in the dev environment. If it is not, check your MIX_ENV environment variable. For our example, the owner of dev-blackcatprojects.xyz in Paraxial.io's web interface would refresh the site overview page, and see the number of allowed requests has increased. This means data is flowing, and the install was successful. If data is not flowing, check the following: Did you put the configuration in the dev.exs file? Is the paraxial_cloud_ip value correct? Does it match the site? Is the paraxial_url set to &quot;https://app.paraxial.io&quot; , with quotes? If you are storing paraxial_api_key as an environment variable, is it set? Can your application read it? What mix environment is your application running in? Is it dev? Customer support is available to help, email support@paraxial.io .","ref":"getting_started.html#7-test-that-paraxial-works-in-dev","title":"Getting started with Paraxial.io - 7. Test that Paraxial works in dev","type":"extras"},{"doc":"Go to the test- site you created, for example test-blackcatprojects.xyz , and get the API key. If you have not created a test site yet, create it now and get the API key. Set fetch_cloud_ips to false to speed up testing, then run mix test . config :paraxial , paraxial_api_key : &quot;API_KEY&quot; , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : false","ref":"getting_started.html#8-configure-test-environment-run-tests","title":"Getting started with Paraxial.io - 8. Configure test environment, run tests","type":"extras"},{"doc":"Now that you have paraxial configured for your dev and test environments, configure it for your prod environment, using the api key from your prod- prefixed site. config :paraxial , paraxial_api_key : &quot;API_KEY&quot; , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true If you are deploying on a platform-as-a-service such as Gigalixir or Fly.io, ensure you have installed remote_ip to re-write conn.remote_ip to the correct value. You have successfully installed Paraxial.io. To take full advantage of Paraxial, some additional configuration is required in your application code.","ref":"getting_started.html#9-configure-prod-environment","title":"Getting started with Paraxial.io - 9. Configure prod environment","type":"extras"},{"doc":"The Paraxial agent allows you to collect information about which IP addresses are attempting to login in to which accounts in your application, and if those logins were successful. This is possible by setting two values in your conn assigns, :paraxial_login_success and :paraxial_login_user_name . The code below was generated using the mix auth generator, however your application may require setting these values in different locations. The example below is given to illustrate how to set the assigns. conn = assign ( conn , :paraxial_login_user_name , email ) conn = assign ( conn , :paraxial_login_success , true ) conn = assign ( conn , :paraxial_login_success , false )","ref":"getting_started.html#10-optional-send-user-login-data-to-backend","title":"Getting started with Paraxial.io - 10. (Optional) Send user login data to backend","type":"extras"},{"doc":"When the Paraxial agent starts, the fetch_cloud_ips configuration key determines if the agent will retrieve a data structure containing many cloud provider's public IP ranges. (AWS, GCP, Digital Ocean, etc.) The reason this is useful is that a request coming from one of these IPs is highly likely to be a bot, and not a human user. For example, you probably do not want to allow a cloud server to send login attempts to your application. There are two plugs that make use of this feature, AssignCloudIP and BlockCloudIP . AssignCloudIP will add metadata to the conn , but will never block an incoming request. When a conn passes through it, if conn.remote_ip matches a cloud provider, the conn's assigns will be updated with that info. This can be viewed in the Paraxial backend, under the site's &quot;HTTP Traffic&quot; page. If you want to block this traffic, use the BlockCloudIP plug. For the Havana example, we want to block cloud IPs from accessing routes in the :browser pipeline. This plug can be used in your endpoint.ex or router.ex file. If your application has API endpoints that bots rely on, for example a data API intended to be used by bots, take care to only use this plug for the appropriate routes. It is discouraged to use BlockCloudIP in your endpoint.ex file, and instead use it in a router pipeline for specific routes.","ref":"getting_started.html#11-optional-determine-if-incoming-request-has-a-cloud-provider-s-ip-address","title":"Getting started with Paraxial.io - 11. (Optional) Determine if incoming request has a cloud provider's IP Address","type":"extras"},{"doc":"Now that Paraxial is working in your application, define a rule to prevent credential stuffing. When one IP address sends &gt; 5 POST requests to /users/log_in, in a period of 5 seconds, it will be banned and an alert will be created.","ref":"getting_started.html#12-define-a-rule-to-block-credential-stuffing","title":"Getting started with Paraxial.io - 12. Define a rule to block credential stuffing","type":"extras"},{"doc":"","ref":"user_manual.html","title":"User Manual","type":"extras"},{"doc":"Welcome to the Paraxial.io user manual. This document focuses on using Paraxial.io to effectively block malicious traffic to a site, and requires you to first install the Paraxial.io agent. Index Definitions Creating a New Site The Overview Page Defining Rules Rule Events Allow/Block List HTTP Traffic Site Settings Webhooks Exclude data collection for specific routes FAQ","ref":"user_manual.html#introduction","title":"User Manual - Introduction","type":"extras"},{"doc":"Site - An Elixir/Phoenix/Plug web application that has the Paraxial agent installed and running. You create a site through the Paraxial web interface, provide the site API key to the Paraxial agent, and a connection is established between the Paraxial server and your application. A site has many rules, allowed IP addresses, banned IP address, and site members. Rule - A user defined condition such as, &quot;If one IP address sends &gt; 20 POST requests to /users/log_in in a period of 5 seconds, create an alert and ban the IP address.&quot; A benefit of Paraxial over traditional systems is that if an IP sending hundreds of requests per second, it will only be permitted to send 20 requests, the 21st will be banned. Compare this with a periodic database query, which would allow hundreds of requests before banning the client. Rule Event - When an IP address matches a rule, such as, &quot;If an IP sends &gt; 20 POST requests to /users/log_in in a period of 5 seconds, alert and ban&quot;, a rule event is created. The rule event contains information about what caused the rule to be triggered. Allow List - A list of IP prefixes defined by the user. If an IP matches a prefix on this list, it will always be allowed through. Supports IPv4 and IPv6 prefixes. Ban List - Similar to Allow List, matching requests will never succeed. Supports IPv4 and IPv6 prefixes. Site Admin - Has full control over the site. Site User - Limited control over a site, for example this user cannot delete the site.","ref":"user_manual.html#1-definitions","title":"User Manual - 1. Definitions","type":"extras"},{"doc":"When you first create a site, select an appropriate name and timezone. Navigate to &quot;Site Settings&quot;, and note the site API key. You will use it to install the Paraxial agent.","ref":"user_manual.html#2-creating-a-new-site","title":"User Manual - 2. Creating a New Site","type":"extras"},{"doc":"The Paraxial.io overview page shows several interesting facts about your site, including: Allowed and blocked requests Total IP addresses Hourly and daily charts Click the &quot;7 Days&quot; link in the upper right hand corner to switch to the week view.","ref":"user_manual.html#3-the-overview-page","title":"User Manual - 3. The Overview Page","type":"extras"},{"doc":"Paraxial.io allows users to define &quot;Rules&quot;, which are conditions in their web application related to incoming HTTP traffic. The following are examples of rules: If an IP sends &gt; 5 POST requests to /accounts/new_user in a 20 second period, create an alert. If an IP sends &gt; 10 requests of any HTTP method to /projects/*/export in a 12 second period, create an alert and ban the IP address. If an IP sends &gt; 100 requests of any HTTP method to any path in a 5 second period, ban the IP address. The purpose of defining rules is to prevent a malicious client from sending an excessive number of unwanted requests. Some examples of requests that you may want to throttle may be related to: Login attempts New account creation Credit card transactions Email sending Expensive computation Excessive total requests (scraping, vulnerability scanning) Denial of service attacks The Rule Creation Form: To create a rule, navigate to: app.paraxial.io/site/:your_site/new_rule You should see a form that says Create new rule for :your_site , with some fields. These are: Rule name - A user provided string, it should be a descriptive comment on what the rule intends to do. N requests - The number of requests one IP address can make in the given time period before matching the rule. Time period in seconds - If you wish to limit login requests to 10 every 5 seconds, this value should be 5. Path - The path of the incoming request. Uses a custom pattern matching language detailed below. HTTP Methods - Examples include GET, PUT, POST. Uses a custom pattern matching language detailed below. On trigger - When the rule is matched, you may create an alert, ban the IP, or do both. Example Rule Creation To create the rule If an IP sends &gt; 5 POST requests to /accounts/new_user in a 20 second period, create an alert and ban the IP address , the following form values are used: Rule name - This is an arbitrary value, written to be understood by users of Paraxial.io. You could name this &quot;Alert and ban on excessive logins in short period&quot;, or &quot;ATO &gt; 5 in 20s to /accounts/new_user&quot;. The behavior of the rule is independent of this string, similar to comments in a programming language. N requests - 5 Time period in seconds - 20 Path - /accounts/new_user - This must be entered exactly as provided here. If your value does not start with a / , it will be rejected. More details are below on how path matching works. HTTP Methods - POST - This must be entered exactly as provided here. More details on http method matching below. On trigger - Create an alert and ban the IP Field Details N requests N requests must be &gt; 0 and &lt; 999. Time period in seconds Time period in seconds must be &gt; 0 and &lt; 86,400. Path The &quot;Path&quot; field uses a custom language for matching on paths. Examples are: Path * - Match any path. Matching: paraxial.io/new_user paraxial.io/site/paraxial.io/settings paraxial.io/site/paraxial.io/edit_users/update Path /new_user - Only matching incoming requests for the route new_user . Matching: paraxial.io/new_user paraxial.io/new_user/ paraxial.io/new_user// paraxial.io/new_user/// Will not match: paraxial.io/new_user/a/new_user paraxial.io/new_user/! paraxial.io/new_user/a Path /site/*/settings - Matching incoming requests for the route /site/:any_value/settings . Matching: paraxial.io/site/paraxial.io/settings paraxial.io/site/paraxial.io/settings/ paraxial.io/site/customsitehere.com/settings paraxial.io/site/customsitehere.com/settings/ Will not match: paraxial.io/site/paraxial.io paraxial.io/site/paraxial.io/settings/edit_users Path /site/*/settings/* - Matching incoming requests for the route /site/:any_value/settings/:any_value . Matching: paraxial.io/site/paraxial.io/edit_users paraxial.io/site/paraxial.io/list_users Will not match: paraxial.io/site/paraxial.io/edit_users/update paraxial.io/site/paraxial.io HTTP Methods The HTTP Methods field takes a list of comma separated HTTP method names, such as: GET, POST, PUT for use in rule matching. It also supports the wildcard * character, to match all HTTP methods. These are: GET, HEAD, POST, PUT, DELETE, CONNECT, OPTIONS, TRACE, PATCH To match all HTTP methods, input: * To match GET only, input: GET To match GET and POST, input: GET, POST To match GET, POST, and PUT, input: GET, POST, PUT On Trigger There are three options for On Trigger : Create alert and ban the IP Only alert, do not ban Only ban, do not alert","ref":"user_manual.html#4-defining-rules","title":"User Manual - 4. Defining Rules","type":"extras"},{"doc":"The rule events page lists useful information about why an IP address matched a rule. This includes: The rule that was matched How many requests the IP sent in the rule time period If the IP is currently on the allow or ban lists Associated login attempts from the IP, if paraxial_login_user_name and paraxial_login_success assigns are in use by your application The matching HTTP requests, with timestamps","ref":"user_manual.html#5-rule-events","title":"User Manual - 5. Rule Events","type":"extras"},{"doc":"The IP block and allow lists support IPv4 and IPv6 prefixes. Examples include: 3.5.140.0/22 2600:1f14:fff:f800::/56","ref":"user_manual.html#6-allow-block-list","title":"User Manual - 6. Allow/Block List","type":"extras"},{"doc":"This page displays the most recent 1,000 HTTP events for your site. For each request, you can see: IP Address HTTP method Path requested Status code (200, 404, etc.) Currently logged in user, if paraxial_current_user assigns is used User Agent If the request was allowed IP Class, set if the IP matches a cloud provider (AWS, GCP, etc.) Timestamp","ref":"user_manual.html#7-http-traffic","title":"User Manual - 7. HTTP Traffic","type":"extras"},{"doc":"Current settings are: Change site timezone Delete site (and all associated site data) Add/remove users to your site Configure Webhooks","ref":"user_manual.html#8-site-settings","title":"User Manual - 8. Site Settings","type":"extras"},{"doc":"To configure webhook URLs: Site &gt; Site Settings &gt; Edit Webooks The outbound POST request will be sent on rule events with &quot;alert&quot; configured. That is, &quot;Create an alert and ban the IP&quot; or &quot;Only alert, do not ban&quot;. If you need a fast way to test this locally, nrgok is useful. { &quot;event_uuid&quot; : &quot;a14c3232-cb2a-42e6-834c-01f008481add&quot; , &quot;failed_logins&quot; : { &quot;attacker2@bots.io&quot; : 1 , &quot;attacker@bots.io&quot; : 1 } , &quot;http_methods&quot; : &quot;.*&quot; , &quot;ip_address&quot; : &quot;3.5.140.2&quot; , &quot;max_requests&quot; : 10 , &quot;on_trigger&quot; : &quot;alert&quot; , &quot;path&quot; : &quot;^/+users/+log_in/*$&quot; , &quot;recorded_request_count&quot; : 12 , &quot;rule_name&quot; : &quot;Too many login&quot; , &quot;site_name&quot; : &quot;local.house.com&quot; , &quot;successful_logins&quot; : { &quot;mike@blackcatprojects.xyz&quot; : 1 } , &quot;time_seconds&quot; : 30 , &quot;timestamp&quot; : &quot;2022-09-01 16:46:45-04:00 EDT&quot; } event_uuid : Corresponds to the rule event UUID in the GUI failed_logins : List of email addresses, and the number of failed logins for each, for the past 7 days http_methods : The HTTP methods (GET, POST, PUT) that match the defined rule ip_address : The IP of the client that triggered the alert max_requests : The maximum number of requests a client may send before triggering the rule on_trigger : Can be &quot;alert&quot;, &quot;ban&quot;, or &quot;alert_ban&quot; path : The Phoenix router path for matching requests recorded_request_count : The number of requests the client sent to trigger the alert rule_name : The user-defined name of the rule site_name : The user-defined name of the site the rule event was created for successful_logins : List of email addresses, and number of successful logins for each, for past 7 days time_seconds : The duration of the rule for request matching timestamp : The time the rule was triggered, timezone determined by site settings","ref":"user_manual.html#9-webhooks","title":"User Manual - 9. Webhooks","type":"extras"},{"doc":"The pricing on Paraxial.io is by the number of good events sent by the agent to the backend. A good event means one HTTP request sent to your web app. So if 5 users send a total of 50 requests, that's 50 good events. If a spammer sends 5,000 blocked requests, those don't count. By default, the agent sends all HTTP requests to the backend. To only collect data for specific routes, set your configuration at compile time to the code below, by editing your config/dev.exs , config/test.exs , and config/prod.exs files. Do NOT set only: or except: at runtime, the agent uses metaprogramming to generate code at compile time. If you set only: or except: at runtime, the agent will ignore the config and send data for all routes. To have the agent only send data to the backend for the following: GET /users/log_in POST /users/log_in GET /users/:id/settings config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , ... only : [ %{ path : &quot;/users/log_in&quot; , method : &quot;GET&quot; } , %{ path : &quot;/users/log_in&quot; , method : &quot;POST&quot; } %{ path : &quot;/users/:id/settings&quot; , method : &quot;POST&quot; } ] To send events for all routes, except the following: GET /health_check GET /users/:id/status config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , ... except : [ %{ path : &quot;/health_check&quot; , method : &quot;GET&quot; } %{ path : &quot;/users/:id/status&quot; , method : &quot;GET&quot; } ] If this change does not work in your local development environment, run: MIX_ENV = dev mix deps . compile -- force paraxial Note that you should only define rules for routes that have collection enabled. If you define a rule for a route, but disable collection for it, the rule will not work correctly. If an attacker is banned due to triggering a rule, the attacker will be banned from all routes in your application, even if collection is not enabled for those routes.","ref":"user_manual.html#10-exclude-data-collection-for-specific-routes","title":"User Manual - 10. Exclude data collection for specific routes","type":"extras"},{"doc":"Honeypot URLs are used to create forms that are only visible by bots, not human visitors. Bots will fill in and submit the form, then be banned by Paraxial.io, preventing them from spamming your real forms. 1. Create the URL in your application Site settings &gt; Honeypot URLs &gt; Edit &gt; Create URL Looks like: https://app.paraxial.io/api/form_submit/e371b5a4-b698-4c60-8072-f024fad67fae 2. Find a controller that does not require auth, create the following action: def honeypot_ban ( conn , _params ) do url = YOUR_URL_HERE body = Jason . encode! ( %{ &quot;bad_ip&quot; =&gt; Tuple . to_list ( conn . remote_ip ) } ) headers = [ { &quot;Content-Type&quot; , &quot;application/json&quot; } ] Task . start ( fn -&gt; HTTPoison . post! ( url , body , headers ) end ) json ( conn , %{ ok : &quot;system online&quot; } ) end 3. In your router, find a scope that goes through the :browser pipeline (for CSRF protection) and does not require auth, for example: scope &quot;/&quot; , ParaxWeb do pipe_through :browser post &quot;/customer&quot; , PageController , :honeypot_ban end 4. Create the form, with CSRF protection Email/password example: &lt; % = form_for @conn , Routes . page_path ( @conn , :honeypot_ban ) , [ style : &quot;display:none !important&quot; ] , fn f -&gt; % &gt; &lt; % = text_input f , :email , tabindex : - 1 % &gt; &lt; % = text_input f , :password , tabindex : - 1 % &gt; &lt; % = submit &quot;Register&quot; % &gt; &lt; % end % &gt;","ref":"user_manual.html#11-honeypot-urls","title":"User Manual - 11. Honeypot URLs","type":"extras"},{"doc":"Do my users need to wait for a round trip network connection because of Paraxial.io? No, the analysis takes place in the agent, there is no round-trip network connection required. What happens in my application if the Paraxial.io agent cannot communicate with the Paraxial.io backend? The agent will fail open, so your application will continue to function as it normally would without the agent installed. How long is my site's data stored? Seven days, after which it is automatically deleted.","ref":"user_manual.html#12-faq","title":"User Manual - 12. FAQ","type":"extras"},{"doc":"","ref":"install.html","title":"Agent Quick Install","type":"extras"},{"doc":"This is a concise list of steps to install the Paraxial.io agent. It is intended for users who have already read the agent guide.","ref":"install.html#introduction","title":"Agent Quick Install - Introduction","type":"extras"},{"doc":"{ :paraxial , &quot;~&gt; 1.1.0&quot; }","ref":"install.html#1-mix-install","title":"Agent Quick Install - 1. Mix install","type":"extras"},{"doc":"config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , # Required paraxial_url : &quot;https://app.paraxial.io&quot; , # Required fetch_cloud_ips : true , # Optional, default is false bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , # Optional, see https://hexdocs.pm/paraxial/Paraxial.html#functions trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) # Optional, see https://hexdocs.pm/paraxial/Paraxial.html#functions Set the PARAXIAL_API_KEY environment variable to keep this secret out of source code.","ref":"install.html#2-config","title":"Agent Quick Install - 2. Config","type":"extras"},{"doc":"plug RemoteIp plug Paraxial.AllowedPlug plug Paraxial.RecordPlug plug HavanaWeb.Router plug Paraxial.RecordPlug","ref":"install.html#3-edit-endpoint-ex","title":"Agent Quick Install - 3. Edit endpoint.ex","type":"extras"},{"doc":"defmodule HavanaWeb.Router do ... pipeline :browser do ... plug Paraxial.CurrentUserPlug end Note: Only works with assign(conn, :paraxial_current_user, conn.assigns.current_user.email)","ref":"install.html#4-optional-to-send-current-user-edit-router-ex-add-paraxial-currentuserplug","title":"Agent Quick Install - 4. (Optional) To send current user, edit router.ex, add Paraxial.CurrentUserPlug","type":"extras"},{"doc":"In your application code, determine how a user's login attempt flows through the code. You are looking for the line right before the user's provided email and password are checked against the database. Once you find that location, re-write the conn with: conn = assign(conn, :paraxial_login_user_name, email) Where email is the user provided string for a login attempt.","ref":"install.html#5-optional-send-paraxial_login_user_name-via-assigns","title":"Agent Quick Install - 5. (Optional) Send :paraxial_login_user_name via assigns","type":"extras"},{"doc":"conn = assign(conn, :paraxial_login_success, false)","ref":"install.html#6-optional-send-login-success-true-or-false","title":"Agent Quick Install - 6. (Optional) Send login success true or false","type":"extras"},{"doc":"In your Paraxial.io config, you can define :bulk and :trusted_domains bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) In your application code, Paraxial.bulk_allowed?(user.email, :email, length(list_of_emails)) will return true or false, depending on the value of the third argument (an integer), and if the email matching a trusted domain.","ref":"install.html#7-optional-use-the-paraxial-bulk_allowed-3-function","title":"Agent Quick Install - 7. (Optional) Use the Paraxial.bulk_allowed?/3 function","type":"extras"},{"doc":"To only collect data for specific routes, set your configuration at compile time to the code below, by editing your config/dev.exs , config/test.exs , and config/prod.exs files. Do NOT set only: or except: at runtime, the agent uses metaprogramming to generate code at compile time. If you set only: or except: at runtime, the agent will ignore the config and send data for all routes. To have the agent only send data to the backend for the following: GET /users/log_in POST /users/log_in GET /users/:id/settings config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , ... only : [ %{ path : &quot;/users/log_in&quot; , method : &quot;GET&quot; } , %{ path : &quot;/users/log_in&quot; , method : &quot;POST&quot; } %{ path : &quot;/users/:id/settings&quot; , method : &quot;POST&quot; } ] To send events for all routes, except the following: GET /health_check GET /users/:id/status config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , ... except : [ %{ path : &quot;/health_check&quot; , method : &quot;GET&quot; } %{ path : &quot;/users/:id/status&quot; , method : &quot;GET&quot; } ] If this change does not work in your local development environment, run: MIX_ENV = dev mix deps . compile -- force paraxial","ref":"install.html#8-optional-configure-the-agent-to-only-send-events-for-specific-routes","title":"Agent Quick Install - 8. (Optional) Configure the agent to only send events for specific routes","type":"extras"},{"doc":"To have the agent send data to the backend for all routes, except certain ones: GET /health_check Set your config to: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , ... except : [ %{ path : &quot;/users/health_check&quot; , method : &quot;GET&quot; } ]","ref":"install.html#9-optional-configure-the-agent-to-exclude-events-for-specific-routes","title":"Agent Quick Install - 9. (Optional) Configure the agent to exclude events for specific routes","type":"extras"},{"doc":"","ref":"code_scans.html","title":"Code Scans","type":"extras"},{"doc":"There are three popular security tools for ensuring the security of Phoenix applications: Sobelow , for static analysis of source code for vulnerabilities, https://github.com/nccgroup/sobelow deps.audit , to scan a project's dependencies for vulnerabilities, https://github.com/mirego/mix_audit hex.audit , to scan for dependencies that have been marked as retired, https://hexdocs.pm/hex/Mix.Tasks.Hex.Audit.html It may seem straightforward to integrate these tools into your existing CI/CD pipeline, but consider the following questions: When was the last time the scan ran successfully? Do you have a record of when all these scans happened? Did the numbers of vulnerabilities increase or decrease compared to the previous scans? How do you view the findings of the most recent scan? Of a scan from 3 months ago? With the Paraxial.io agent version 1.1.0, you now have access to the command: mix paraxial . scan This will run Sobelow , deps.audit , and hex.audit on your application, then upload the results to the Paraxial.io backend:","ref":"code_scans.html#introduction","title":"Code Scans - Introduction","type":"extras"},{"doc":"In the Paraxial.io web interface, create a site for each environment you want to perform scans in. These are typically dev , test , or prod . For this tutorial, we use dev . In the &quot;Site Settings&quot; page, get your Site API key. In your Phoenix app, open config/dev.exs and add: config :paraxial , paraxial_api_key : &quot;API_KEY&quot; , paraxial_url : &quot;https://app.paraxial.io&quot; , Add the Paraxial.io agent as a config in mix.exs : { :paraxial , &quot;~&gt; 1.1.0&quot; }","ref":"code_scans.html#1-create-your-site-add-the-paraxial-io-agent","title":"Code Scans - 1. Create your site, add the Paraxial.io agent","type":"extras"},{"doc":"While it's not necessary to install Sobelow, having it installed will allow you to flag specific findings as false positives. You can read more about how to flag false positives here - https://github.com/nccgroup/sobelow#false-positives { :sobelow , &quot;~&gt; 0.11.1&quot; }","ref":"code_scans.html#2-install-sobelow","title":"Code Scans - 2. Install Sobelow","type":"extras"},{"doc":"Run mix deps.get to install the Paraxial.io agent. To see if the install was successful, run: mix paraxial . scan If the agent is installed correctly, and your site's API key is correct, you should see the following output: 19 : 36 : 42.184 [ info ] [ Paraxial ] API key found , scan results will be uploaded [ Paraxial ] Scan findings : % Paraxial.Scan { api_key : &quot;REDACTED&quot; , findings : [ % Paraxial.Finding { ...","ref":"code_scans.html#3-test-the-install","title":"Code Scans - 3. Test the install","type":"extras"},{"doc":"The scan task will run Sobelow , deps.audit , and hex.audit on your project, and print the results in the terminal. Go to your site in app.paraxial.io to see the scan results, and a history of previous scans.","ref":"code_scans.html#4-view-the-scan-results","title":"Code Scans - 4. View the scan results","type":"extras"},{"doc":"","ref":"readme.html","title":"Paraxial.io Agent Guide","type":"extras"},{"doc":"Welcome to the Paraxial.io agent documentation. This page will introduce you to key features of the agent, how to install it in your project, and how to use conn assigns for sending select user data to the backend. Index Agent Features Detailed Installation Instructions Debugging Installation Errors Paraxial Functions Paraxial Plugs Assigns Additional Documentation If you are already familiar with the Paraxial.io agent, and are looking for a concise set of steps to install the agent, without exposition, see the install page.","ref":"readme.html#introduction","title":"Paraxial.io Agent Guide - Introduction","type":"extras"},{"doc":"Allowing and Blocking Requests When a request arrives in an application protected by Paraxial.io, the agent determines if the request should be allowed or blocked. A request may be blocked for many reasons, such as matching a user-defined rule, belonging to a cloud provider's IP range, or being placed on a site's ban list by a user. An example of a user defined rule is, &quot;If one IP address sends &gt; 10 login requests in 5 seconds, ban it&quot;. The decision to allow or deny a request is based on the value of conn.remote_ip . If you are hosting your Phoenix application behind a proxy, this value is probably different from the real IP of the client. To fix this, use the remote_ip library. Cloud IP Range Matching The agent is able to determine if an incoming request's IP address matches the IP range of several major cloud providers. For more details, see cloud ip matching. Trusted Domains and Bulk Actions If the Paraxial.io customer application contains code for a bulk action, such as a user sending dozens of emails with a single POST request, the agent can maintain a data structure of &quot;trusted&quot; domains. Users from these trusted domains can be granted a higher threshold for the bulk action, compared with users from untrusted domains. This means mike@paraxial.io can send up to 100 emails at a time, while kyle@10minmail.com will be limited to 3. Data Forwarding to Paraxial.io Backend The agent forwards data about incoming requests to the Paraxial.io backend. There are several paraxial_ prefixed assigns available, to add information about the customer application's users to this data. For example, if you want to quickly determine which requests are associated with logged-in users, use the :paraxial_current_user assigns.","ref":"readme.html#1-agent-features","title":"Paraxial.io Agent Guide - 1. Agent Features","type":"extras"},{"doc":"(Optional) Install remote_ip in your application If your application is showing a different conn.remote_ip than expected, it is probably behind a proxy. Install the remote_ip library to fix this. Use plug Plug.RequestId in your application's endpoint.ex file: The majority of Phoenix applications do this by default. Check your endpoint.ex file for the line: plug Plug.RequestId This plug sets x-request-id , which is required for the Paraxial agent to work correctly. If it does not exist, add it to your project. Install :paraxial in your application's mix.exs file: def deps do [ { :paraxial , &quot;~&gt; 1.1.0&quot; } ] end Application Configuration: In your Paraxial.io account, we recommend creating two different sites for your application. One site for development/testing, and one site for production. For your local environment, edit your application's config/dev.exs : config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) Configuration keys and values: paraxial_api_key - Found in your site's settings page. Required for secure communication between the agent and Paraxial.io backend service. paraxial_url - This is https://app.paraxial.io . fetch_cloud_ips - By default, Paraxial.io will sent HTTP requests to retrieve the public IP ranges of several cloud providers. If you wish to disable this, set fetch_cloud_ips to false . When disabled, matching incoming requests against cloud IP addresses will not work. bulk and trusted_domains - In the above example, user emails ending in @paraxial.io or @blackcatprojects.xyz will be able to send up to 100 emails. Emails from different domains can only send 3. These values are optional. Configure Plugs Open endpoint.ex and add the required plugs: plug RemoteIp plug Paraxial.AllowedPlug plug Paraxial.RecordPlug plug HavanaWeb.Router plug Paraxial.RecordPlug The duplicated Paraxial.RecordPlug before and after the router is intentional, it is done to record requests that fail to match in the router.","ref":"readme.html#2-detailed-installation-instructions","title":"Paraxial.io Agent Guide - 2. Detailed Installation Instructions","type":"extras"},{"doc":"Check that your application is configured correctly. 1. Set your application's local logging level to debug. This will allow you to see debug messages from the Paraxial agent. Example config/dev.exs : config :logger , level : :debug 2. Check the Paraxial lines in config/dev.exs are similar to: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true , bulk : %{ email : %{ trusted : 100 , untrusted : 3 } } , trusted_domains : MapSet . new ( [ &quot;paraxial.io&quot; , &quot;blackcatprojects.xyz&quot; ] ) The following values are optional: fetch_cloud_ips bulk trusted_domains 3. Start your application locally, read the debug lines from Paraxial. Bad start: @ house % mix phx . server [ warning ] Paraxial API key not found . This warning means your application is not configured correctly. Check your config files. Bad start: [ info ] Paraxial URL and API key found . [ info ] [ Paraxial ] :fetch_cloud_ips not set . No requests sent . [ info ] [ Paraxial ] Agent starting supervisor . [ info ] Running HouseWeb.Endpoint with cowboy 2.9 . 0 at 127.0 . 0.1 : 4002 ( http ) [ info ] Access HouseWeb.Endpoint at http :// localhost : 4002 [ error ] Task # PID &lt; 0 . 603 . 0 &gt; started from Paraxial.Crow terminating ** (FunctionClauseError) no function clause matching in Access.get/3 Check that your paraxial_url starts with https and not http . Also check that your API key is entered correctly. Good start: [ info ] Paraxial URL and API key found . [ info ] [ Paraxial ] :fetch_cloud_ips set to true , fetching ... [ debug ] [ Paraxial ] Prefixes downloaded for aws : 8075 [ debug ] [ Paraxial ] Prefixes downloaded for azure : 56752 [ debug ] [ Paraxial ] Prefixes downloaded for digital_ocean : 1644 [ debug ] [ Paraxial ] Prefixes downloaded for gcp : 540 [ debug ] [ Paraxial ] Prefixes downloaded for oracle : 492 [ debug ] [ Paraxial ] Prefixes length with duplicates : 67503 [ debug ] [ Paraxial ] Iptrie count - 39566 [ debug ] [ Paraxial ] Iptrie size in MB : 1.233269 [ info ] [ Paraxial ] Agent starting supervisor . [ info ] Running HouseWeb.Endpoint with cowboy 2.9 . 0 at 127.0 . 0.1 : 4002 ( http ) [ info ] Access HouseWeb.Endpoint at http :// localhost : 4002 [ watch ] build finished , watching for changes ... [ debug ] [ Paraxial ] HTTPBuffer sending POST request [ debug ] :ok","ref":"readme.html#3-debugging-installation-errors","title":"Paraxial.io Agent Guide - 3. Debugging Installation Errors","type":"extras"},{"doc":"As of 1.1.0 there is only one Paraxial function intended for use by users: Paraxial.bulk_allowed?/3","ref":"readme.html#4-paraxial-functions","title":"Paraxial.io Agent Guide - 4. Paraxial Functions","type":"extras"},{"doc":"The Paraxial.io Agent provides several Plugs to be used in your application code: Paraxial.AllowedPlug - Required, this Plug determines if an incoming requests matches your allow/block lists. If a request is halted by this Plug, internally Paraxial will still record it. Paraxial.RecordPlug - Required, records incoming HTTP requests into a local buffer, then sends them to the Paraxial.io backend. Paraxial.AssignCloudIP - Optional, if the remote_ip of an incoming request matching a cloud provider IP address, this plug will add metadata to the conn via an assigns. For example, if a conn's remote_ip matches aws, this plug will do assigns(conn, :paraxial_cloud_ip, :aws) . Paraxial.BlockCloudIP - Optional, similar to AssignCloudIP. When a conn matches a cloud provider IP, the assign is updated and the conn is halted, with a 404 response sent to the client. Paraxial.CurrentUserPlug - Optional, only works if conn.assigns.current_user.email is set. Sets the :paraxial_current_user assigns by calling assign(conn, :paraxial_current_user, conn.assigns.current_user.email)","ref":"readme.html#5-paraxial-plugs","title":"Paraxial.io Agent Guide - 5. Paraxial Plugs","type":"extras"},{"doc":"This is a table of every Paraxial assigns value. To avoid conflict with assigns in your application code, each assigns key is prefixed with paraxial . Key Set By Type :paraxial_login_success User Application Boolean :paraxial_login_user_name User Application String :paraxial_current_user User Application String :paraxial_cloud_ip Paraxial Agent String (aws, azure, etc.) To monitor login attempts, use: assign ( conn , :paraxial_login_success , true / false ) To monitor the login name for the given login attempt use: assign ( conn , :paraxial_login_user_name , &quot;userNameHere&quot; ) To map incoming requests to the currently logged in user, use: assign ( conn , :paraxial_current_user , &quot;userNameHere&quot; ) The :paraxial_cloud_ip assign is set by Paraxial.AssignCloudIP . If you do not use this assign anywhere in your application code, and just want to block cloud IPs, use Paraxial.BlockCloudIP . Check your configuration to ensure fetch_cloud_ips: true is set.","ref":"readme.html#6-assigns","title":"Paraxial.io Agent Guide - 6. Assigns","type":"extras"},{"doc":"Agent Internals Cloud IPs Brief Install Guide","ref":"readme.html#7-additional-documentation","title":"Paraxial.io Agent Guide - 7. Additional Documentation","type":"extras"},{"doc":"","ref":"agent.html","title":"Agent Internals","type":"extras"},{"doc":"The main tasks of the Paraxial.io agent are: Record incoming HTTP requests and send them to the Paraxial.io backend for processing Enforce bans against IP addresses Enforce rules with a time period of &lt; 30 seconds, using local ETS tables for state","ref":"agent.html#introduction","title":"Agent Internals - Introduction","type":"extras"},{"doc":"Sent to backend: Bundles of HTTP requests, Paraxial.HTTPBuffer.send_http(state), Retrieved from backend for local use: Allow list Ban list Local rules Important values: How often are HTTP request bundles sent to backend? (3 seconds) How often is the allow/ban/rules request sent? (3 seconds) Max length of local rules (30 seconds) Local bans cleared (30 seconds) Paraxial.io backend: @local_rule_max_seconds 30 only rules with a time period &lt; @local_rule_max_seconds are sent to agent","ref":"agent.html#information-sent-received-by-agent","title":"Agent Internals - Information Sent/Received by Agent","type":"extras"},{"doc":"AllowedPlug -&gt; Paraxial.Crow.eval_http(conn) RecordPlug -&gt; Paraxial.HTTPBuffer.add_http_event(conn)","ref":"agent.html#plug-module-function-map","title":"Agent Internals - Plug -&gt; Module -&gt; Function Map","type":"extras"},{"doc":"Crow: :backend_bans :local_bans :rule_names LocalRule: :local_rule_n ets atom is used for table name, created as `:&quot;local_rule \#{rule.id}&quot;`","ref":"agent.html#ets-tables","title":"Agent Internals - ETS Tables","type":"extras"},{"doc":"By default, several Cloud hosting IP ranges are defined in the Paraxial agent: AWS Azure GCP Digital Ocean Oracle This is useful because a login request coming from a rented Cloud IP server is most likely a bot, and should be blocked. To make this data available locally in your agent, ensure fetch_cloud_ips: true is set: config :paraxial , paraxial_api_key : System . get_env ( &quot;PARAXIAL_API_KEY&quot; ) , paraxial_url : &quot;https://app.paraxial.io&quot; , fetch_cloud_ips : true","ref":"cloud_ips.html","title":"Cloud IP Matching","type":"extras"},{"doc":"There are two plugs related to Cloud IP matching: Paraxial.AssignCloudIP Paraxial.BlockCloudIP Paraxial.AssignCloudIP If the remote_ip of an incoming request matching a cloud provider IP address, this plug will add metadata to the conn via an assigns. For example, if a conn's remote_ip matches aws, this plug will do assigns(conn, :paraxial_cloud_ip, :aws) . Use this if your application has branching logic based on if an incoming conn.remote_ip is from a rented server. Paraxial.BlockCloudIP - When a conn matches a cloud provider IP, the assign is updated and the conn is halted, with a 404 response sent to the client. Use this to block cloud IPs, for example in your router's authentication pipeline.","ref":"cloud_ips.html#relevant-plugs","title":"Cloud IP Matching - Relevant Plugs","type":"extras"},{"doc":"Will Paraxial.BlockCloudIP block Google's Crawler? No, Google's Cloud Platform is hosted on a different IP range from Googlebot. Google will still be able to index your site, you are only blocking requests from GCP servers that anyone can rent. What if I want to allow a specific Cloud IP? For example a client has a cloud-hosted VPN with a cloud IP. Add the IP address to your site's Allow List, and it will no longer be blocked by Paraxial.BlockCloudIP","ref":"cloud_ips.html#faq","title":"Cloud IP Matching - FAQ","type":"extras"},{"doc":"","ref":"changelog.html","title":"Paraxial.io Changelog","type":"extras"},{"doc":"Add mix paraxial.scan , code scanning for vulnerabilities.","ref":"changelog.html#1-1-0","title":"Paraxial.io Changelog - 1.1.0","type":"extras"},{"doc":"If fetch_cloud_ips is set to true, and there is no internet connection, ip_trie will be set to an empty trie. PARAXIAL_API_KEY environment variable support added.","ref":"changelog.html#1-0-0","title":"Paraxial.io Changelog - 1.0.0","type":"extras"}]